#ifndef EA_GFX
#define EA_GFX

#include "typen.h"
// diverse Hilfsfunktionen, laedt string.h etc

#include <stdio.h> 
#include <malloc.h> /* stdlib ist fuer malloc uebertrieben ... */

#include <X11/Xlib.h>
#include <X11/Xutil.h>

typedef unsigned short int EA_PIXEL;

#define GFX(x,y,v) v[((y) * W) + (x)]
// GCC 2.7.2 optimiert gut, z.B. bei 16bit-Pixeln und X =320 = (4+1) * 2^6:
// movl Y,%edi , leal (%edi,%edi,4),%eax , sall $6,%eax , 
// movl X,%edx , addl %eax,%edx , movl V,%edi , Zugriff[%edi+%edx*2]Word
// Also: Zeiger = Basis + (Pixelgroesse * ( ((Y*5)<<6) + X ))
// un-optimal ist daran nur, dass addl mit X direkt gegangen waere...

#define RGB(r,g,b) (EA_PIXEL) ( ((b) >> 3) | (((g) >> 2) << 5) | (((r) >> 3) << 11) )
/* 565, low byte first assumed! */

#define KEY ((kbhit()) ? getch() : 0)
#define err_exit(warum) { fprintf(stderr,warum); exit(1); }

#ifndef gfx_clipping
#define gfx_clipping false
#endif
#define CLIP_NEEDED(x1,y1,x2,y2) (gfx_clipping && \
 (((x2) < 0) || ((x1) < 0) || ((x1) >= W) || ((x2) >= W) || \
  ((y1) < 0) || ((y2) < 0) || ((y1) >= H) || ((y2) >= H) )

/* Next part stolen and adapted from "guimauve2" */

#define X            0
#define Y            0
#define W            512
#define H            256
/* z.B. 320x240 */
#define BORDER       0
#define NAME         "Erics Effekte Sammlung"

Display              *dis;
int                  disScreen;
int                  disDepth;
int                  disWidth;
int                  disHeight;

Window               win;
Window               winRoot;
XSetWindowAttributes winAttr;
unsigned long        winMask;
XSizeHints           winHint;

XImage               *xim;
unsigned char        *buffer_byte;
EA_PIXEL             *buffer;
EA_PIXEL             *buffer2;

GC                   gc;
XGCValues            gcVal;
unsigned long        gcMask;

void init_x ();
int  event_x ();
void close_x ();
void show_x ();

#endif
